# Contributing

When contributing to this repository, please check [Issues](https://github.com/storm-devs/storm-engine/issues) and
[Projects](https://github.com/storm-devs/storm-engine/projects).
Also, it's a good idea to drop a message on our [Discord channel](https://discord.gg/jmwETPGFRe)
or start a [discussion](https://github.com/storm-devs/storm-engine/discussions) first to let others know what you're
planning to work on.

## Styleguides

### Git Commit Messages

* Use the present tense and imperative mood
* Limit the first line to 72 characters

### Code Style

To keep the source consistent and easy to merge, we are using ClangFormat to format code.
You can find ``.clang-format`` config in the root.

## Pull Request Process

To make the approval process easier and faster, your pull request should include the following (if applicable):

* A link to issue or project card
* Reasoning of changes
* Summary of changes

There are also some tips:

* If you are working on different features, split the job to branches
* Prefer to rebase over merge when pulling changes from master
* Avoid mixing tasks in a single Pull Request
* Give understandable names for commits
* Be sure that all your changes are clear to understand